(function(){

	if (window.WebViewJavascriptBridge) {
        return;
    }
	var messageingIframe;
	var sendMessageQueueArr = [];
	var successCallBackObj = {};
	var errorCallBackObj = {};
	var uniqueId = 1;

	 var NM_PROTOCOL_SCHEME = 'nybjs';
    var QUEUE_HAS_MESSAGE = '__queue_message__/';

    function createIfream(doc){
		messageingIframe = doc.createElement('iframe');
		messageingIframe.style.display = 'none';
		doc.documentElement.appendChild(messageingIframe);
	}

	function send(handlerName,data,successCallBack,errorCallBack){
		doSend({
			handlerName: handlerName,
			data: data
		},successCallBack,errorCallBack);
	}
	
	function doSend(message,successCallBack,errorCallBack){
		

		var suucessCallbackId = "nm_" + (uniqueId++) + "_" + (new Date()).getTime();
		var errorCallbackId = "nm_" + (uniqueId++) + "_" + (new Date()).getTime();
		
		if (successCallBack) { 
			successCallBackObj[suucessCallbackId] = successCallBack;			
			message.successCallbackId = suucessCallbackId;
		}
		if (errorCallBack) {
			errorCallBackObj[errorCallbackId] = errorCallBack;
			message.errorCallbackId = errorCallbackId;
		};
		sendMessageQueueArr.push(message);
		
		messageingIframe.src = NM_PROTOCOL_SCHEME + "://" + QUEUE_HAS_MESSAGE;
		// alert(messageingIframe.src);
	}

	function fetchMessageQueue(){
		var messageQueueString = JSON.stringify(sendMessageQueueArr);
		sendMessageQueueArr = [];
		// alert(NM_PROTOCOL_SCHEME + '://return/fetchMessageQueue/' + encodeURIComponent(messageQueueString));
		messageingIframe.src = NM_PROTOCOL_SCHEME + '://return/fetchMessageQueue/' + encodeURIComponent(messageQueueString);
	}

	function handleMessageFromNative(messageJSON){
		dispatchMessageFromNative(messageJSON);
	}

	function dispatchMessageFromNative(messageJSON){

		setTimeout(function(){
			var message = JSON.parse(messageJSON);
			// alert(messageJSON);
			// alert(message);

			// var message = messageJSON;
			
			var responseCallBack;
			if (message.responseId) {
				responseCallBack = successCallBackObj[message.responseId];
				if (!responseCallBack) {
					responseCallBack = errorCallBackObj[message.responseId];
				};
				if (!responseCallBack) {
					return;
				};
				var responseJson = JSON.parse(message.responseData);
				responseCallBack(responseJson);
				delete successCallBackObj[message.successCallbackId];
				delete errorCallBackObj[message.errorCallbackId];
			};
		});
	}
	
	 window.WebViewJavascriptBridge = {
	 	send:send,
	 	fetchMessageQueue:fetchMessageQueue,
	 	handleMessageFromNative:handleMessageFromNative
	 };

     //本地接口
	 window.HKNative = {
	    location : function(onSuccess, onError){
        	    window.WebViewJavascriptBridge.send("location", "", onSuccess, onError);
        	 }
	 };

   window.HKWidget = {
        picker : function(params, onSuccess, onError){
            window.WebViewJavascriptBridge.send("picker", params, onSuccess, onError);
        },
        select : function(params, onSuccess, onError){
                window.WebViewJavascriptBridge.send("select", params, onSuccess, onError);
        }
    };

	 window.HKMedia = {
	    chooseImage : function(params, onSuccess, onError){
	        window.WebViewJavascriptBridge.send("chooseImage", params, onSuccess, onError);
	    },
	    previewImage : function(params){
	        window.WebViewJavascriptBridge.send("previewImage", params);
	    },
        uploadImage : function(params, onSuccess, onError){
            window.WebViewJavascriptBridge.send("uploadImage", params, onSuccess, onError);
        },
        getLocalImgData : function(params, onSuccess, onError){
            window.WebViewJavascriptBridge.send("getLocalImgData", params, onSuccess, onError);
        }
	 };

	 //支付
	 window.HKOrder = {
	    pay: function(type, params, onSuccess, onError){
	        // type: 1=>微信，2=>支付宝
            var data = {type: type, params: params};
            window.WebViewJavascriptBridge.send("pay", data, onSuccess, onError);
	    }
	 };

	  // API请求
    window.HKRequest = {
        GET: function(url, params, onSuccess, onError) {
            var data = {url: url, params: params};
            window.WebViewJavascriptBridge.send("get",data,onSuccess,onError);
        },
        POST: function(url, params, onSuccess, onError) {
            var data = {url: url, params: params};
            window.WebViewJavascriptBridge.send("post",data,onSuccess,onError);
        }
    };

    //调用页面
    window.HKNM = {
        whoami: function(className,params,onSuccess) {
        	var data = {className: className, params: params};
        	window.WebViewJavascriptBridge.send("openActivity",data,onSuccess);
        }
    };

    // 用户
    window.HKUser = {
        whoami: function(onSuccess) {
        	window.WebViewJavascriptBridge.send("getUserInfo","",onSuccess);
        },
        checkLogin: function(onSuccess) {
        	window.WebViewJavascriptBridge.send("checkLogin", "", onSuccess);
        }
    };

    //常用事件
    window.HKEvent = {
    		clickEvent : function(type,params){
    			var data = {type : type, params : params};
    			window.WebViewJavascriptBridge.send("clickEvent",data);
    		},
    		countEvent : function(eventId,params){
    			var data = {eventId : eventId, params : params};
    			window.WebViewJavascriptBridge.send("countEvent",data);
    		}
    };

    //展示Menu
    window.HKWebView = {
	    showMenu: function(data) {
	    	// alert("showMenu");
	        // HKWebView.showMenu({"share": {}}, {"collection": {type:xxx,collectionId:xxxx}});
//	        data = {menuTypes : Array.prototype.slice.call(arguments, 0)};

	        window.WebViewJavascriptBridge.send("showMenu",data);
	    },
	    hideMenu: function() {
	        // HKWebView.hideMenu("share", "collection");
	        data = {menuTypes : Array.prototype.slice.call(arguments, 0)};
	        window.WebViewJavascriptBridge.send("hideMenu",data);  
	    }    
	};

    // 商品
    window.HKItem = {
    	showJdPage : function(params){
    		window.WebViewJavascriptBridge.send("showJdPage",params);
    	},
        showTmallPage: function(url) {
            var data = {url: url};
            window.WebViewJavascriptBridge.send("showTmallPage",data);
    	    },
        showTmallDetail: function(openIid, url, params) {
            var data = {openIid: openIid, url: url};
            for (var key in params) {
            	if (params.hasOwnProperty(key)) {
            		data[key] = params[key];
            	};
         	}	
          	window.WebViewJavascriptBridge.send("showTmallDetail",data);
        }
    };

    window.HKNative = {
        notification : function(name, params){
            var data = {name : name, params : params};
            window.WebViewJavascriptBridge.send("notification",data);
        }
    };

	createIfream(document);


	 if (window.onBridgeReady) {
            window.onBridgeReady();
      }

})();